Subject: Bug#1353: [X2Go-Dev] Bug#1353: Bug#1353: with dash as default shell, x2goagent.options are not being parsed correctly

From: Mike Gabriel <[email-masked]>
Date: Thu, 13 Dec 2018 19:29:35 +0000

Hi Stefan,

On Monday, 10 December 2018, Stefan Baur wrote:
> Am 10.12.18 um 15:32 schrieb Stefan Baur:
> >> The x2goagent.options file is sourced by x2gostartagent and that uses
> >> /bin/bash as shebang.
> >>
> >> I am inclined to close this bug unless you have more info. Even if you
> >> user as /bin/dash as default shell, the x2goagent.options file should be
> >> sourced by bash.
> > Interesting.  Please keep it open for now; I will check back with the
> > affected user.  For some reason, their session wasn't picking up the
> > x2goagent.options, and they had /bin/dash as their default shell.
> 
> The user says that not the individual accounts' shell was set to
> /bin/dash, but the system-wide default shell.
> And changing it to /bin/bash fixed the issue for them.
> Grepping through the X2Go code, I found several instances where /bin/sh
> is used (/usr/sbin/x2golistsessions_root, /usr/sbin/x2gocleansessions,
> /usr/bin/x2gopath, /usr/bin/x2gobasepath, /etc/init.d/x2goserver,
> /usr/bin/x2goprint).  There is also a match in the /usr/bin/x2goagent
> binary.
> 
> Could it be that x2gostartagent itself is being called in a way that
> skips the shebang line? (e.g. "/bin/sh -c /usr/bin/x2gostartagent")
>  

Ouch! Good point. We should look at x2goclient debugging output and check how X2Go Client launches x2gostartagent. IIRC, it use such a call as you mentioned above....

Mike

-- 
Sent from my Jolla